#!/usr/bin/env python
# -*- coding: utf-8 -*-

from sys import *
from random import *
from TOSSIM import *
from tinyos.tossim.TossimApp import *

n = NescApp()
t = Tossim(n.variables.variables())
t.addChannel("TEST-LedkyM", sys.stdout)
t.addChannel("TEST-ControlM", sys.stdout)
t.addChannel("TEST-WaitM", sys.stdout)
t.addChannel("Boot", sys.stdout)
t.addChannel("App", sys.stdout)
t.addChannel("ArrayC", sys.stdout)
t.addChannel("ArrayOpC", sys.stdout)
t.addChannel("ArrayDbg", sys.stdout)
t.addChannel("PlatformSvcC", sys.stdout)


r = t.radio()
r.add(1, 2, -34.0)
r.add(2, 1, -34.0)

r.add(2, 3, -31.0)
r.add(3, 2, -31.0)
r.add(2, 4, -34.0)
r.add(4, 2, -34.0)
r.add(2, 5, -31.0)
r.add(5, 2, -31.0)
r.add(2, 6, -34.0)
r.add(6, 2, -34.0)
r.add(2, 7, -31.0)
r.add(7, 2, -31.0)
r.add(2, 8, -34.0)
r.add(8, 2, -34.0)
r.add(2, 9, -31.0)
r.add(9, 2, -31.0)

r.add(3, 4, -34.0)
r.add(4, 3, -34.0)
r.add(3, 5, -31.0)
r.add(5, 3, -31.0)
r.add(3, 6, -34.0)
r.add(6, 3, -34.0)
r.add(3, 7, -31.0)
r.add(7, 3, -31.0)
r.add(3, 8, -34.0)
r.add(8, 3, -34.0)
r.add(3, 9, -31.0)
r.add(9, 3, -31.0)

r.add(4, 5, -34.0)
r.add(5, 4, -34.0)
r.add(4, 6, -31.0)
r.add(6, 4, -31.0)
r.add(4, 7, -34.0)
r.add(7, 4, -34.0)
r.add(4, 8, -31.0)
r.add(8, 4, -31.0)
r.add(4, 9, -34.0)
r.add(9, 4, -34.0)

r.add(5, 6, -31.0)
r.add(6, 5, -31.0)
r.add(5, 6, -34.0)
r.add(6, 5, -34.0)
r.add(5, 7, -31.0)
r.add(7, 5, -31.0)
r.add(5, 8, -34.0)
r.add(8, 5, -34.0)
r.add(5, 9, -31.0)
r.add(9, 5, -31.0)

r.add(6, 7, -34.0)
r.add(7, 6, -34.0)
r.add(6, 8, -31.0)
r.add(8, 6, -31.0)
r.add(6, 9, -34.0)
r.add(9, 6, -34.0)

r.add(7, 8, -31.0)
r.add(8, 7, -31.0)
r.add(7, 9, -34.0)
r.add(9, 7, -34.0)

r.add(8, 9, -31.0)
r.add(9, 8, -31.0)

noise = open("meyer-heavy.txt", "r")
lines = noise.readlines()
for line in lines:
  str = line.strip()
  if (str != ""):
    val = int(str)
    for i in range(1, 10):
      t.getNode(i).addNoiseTraceReading(val)

for i in range(1, 10):
  print "Creating noise model for ",i;
  t.getNode(i).createNoiseModel()

#normalne je to 1..9
for i in range (1, 10):
  t.getNode(i).bootAtTime(i * 2351217 + 23542399)

while t.runNextEvent():
  pass
